import { system, world } from "@minecraft/server";

system.events.beforeWatchdogTerminate.subscribe(data => {
  data.cancel = true;
});


world.events.tick.subscribe(handler);

let activeCommand = false;
let random = "";
let giveConfig = { "item_lock": { "mode": "lock_in_inventory" }, "keep_on_death": {} };

// Detector de Muerte y Resurreccion.
function handler() {
  let players = Array.from(world.getPlayers());
  let w = world.getDimension("overworld");
  for(let i = 0; i < players.length; i++){
    w.runCommandAsync(`gamerule sendcommandfeedback false`);

    // Spawnear tumba y coordenadas.  
    if (players[i].getComponent("health").current == 0 && !players[i].hasTag("death")) {
     random = Math.floor(Math.random() * 100);
     players[i].addTag("death");
     players[i].runCommandAsync(`tellraw @s {"rawtext":[{"translate":"action.players.death"},{"text":"${Math.floor(players[i].location.x)} ${Math.floor(players[i].location.y)} ${Math.floor(players[i].location.z)}"}]}`);
     players[i].runCommandAsync(`summon new:tumba ~~~ minecraft:entity_spawned "${players[i].name}"`);
     players[i].runCommandAsync("tp @e[type=item,r=2.5] ~~~");

   }



   // Otorgar llave random.
   if (players[i].getComponent("health").current > 0 && players[i].hasTag("death") && random < 90) { 
      players[i].runCommandAsync(`give "${players[i].name}" new:key2 1 0 ${JSON.stringify(giveConfig)}`);    
      random = ""; 
      players[i].removeTag("death");
   }
   if (players[i].getComponent("health").current > 0 && players[i].hasTag("death") && random >= 90) {
      players[i].runCommandAsync(`give "${players[i].name}" new:key 1 0 ${JSON.stringify(giveConfig)}`);    
      random = ""; 
      players[i].removeTag("death");
   }

   //Detectar item en el inventario
   let p = players[i];
   let pInv = p.getComponent("inventory");
   let items = getItems(pInv.container);
   let itemSlot = findItem(items, { typeId: "new:key2", amount: '*' });
   let itemSlot2 = findItem(items, { typeId: "minecraft:ender_pearl", amount: '*' });
   if(itemSlot > -1 && itemSlot2 > -1){ 
     activeCommand = true;
   } 
   else if(itemSlot <= -1 || itemSlot2 <= -1){
     activeCommand = false;
   }
 }
}

//Tp a tumbas
world.events.beforeItemUse.subscribe(data => {
  var p = data.source;
  switch (data.item.typeId) {
    case "new:key": {
      p.runCommandAsync(`tp @s @r[type=new:tumba,name="${p.name}"]`);
    } break;
    default:
    break;
  }
});


// Abrir tumba por el dueño
world.events.entityHit.subscribe(hitEnt => {
  let hit = hitEnt.hitEntity;
  let entity = hitEnt.entity;
  let inventory = entity.getComponent("inventory");
  let container = inventory.container;
  let hand = container.getItem(entity.selectedSlot);

  if(entity.typeId == "minecraft:player" && hit.typeId == "new:tumba" && hand && hand.typeId == "new:key_multi"){
    hit.runCommandAsync(`event entity @s new:entity_death`);
    entity.runCommandAsync(`clear @s new:key_multi 0 1`);
  } 

  if(entity.typeId == "minecraft:player" && hit.typeId == "new:tumba" && hit.nameTag == entity.nameTag && hand){
    if(hand.typeId == "new:key"){
      hit.runCommandAsync(`event entity @s new:entity_death`);
      entity.runCommandAsync(`clear @s new:key 0 1`); 
      let random2 = Math.floor(Math.random() * 100);
      if(random2 > 85 && random2 <= 90){
        hit.runCommandAsync(`summon zombie ~~~ minecraft:entity_spawned "${entity.nameTag}"`);
      }
      if(random2 > 95 && random2 <= 100){
        hit.runCommandAsync(`summon skeleton ~~~ minecraft:entity_spawned "${entity.nameTag}"`);
      }
    }
    if(hand.typeId == "new:key2"){
      hit.runCommandAsync(`event entity @s new:entity_death`);
      entity.runCommandAsync(`clear @s new:key2 0 1`);
      
      let random2 = Math.floor(Math.random() * 100);
      if(random2 > 85 && random2 <= 90){
        hit.runCommandAsync(`summon zombie ~~~ minecraft:entity_spawned "${entity.nameTag}"`);
      }
      if(random2 > 95 && random2 <= 100){
        hit.runCommandAsync(`summon skeleton ~~~ minecraft:entity_spawned "${entity.nameTag}"`);
      }
    }
  } 
  else if(hit.nameTag != entity.nameTag && hit.typeId == "new:tumba"){
    if(hand.typeId == "new:key2" || hand.typeId == "new:key"){
      entity.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"action.players.warn"},{"text":"${hit.nameTag}"}]}`)
    }
  }
});

//Comando Custom
let prefix = "&";
world.events.beforeChat.subscribe(e => {
  let msg = e.message;
  if (msg.startsWith(prefix)) {
    let args = msg.slice(prefix.length).split(" ");
    let cmd = args.shift().toLowerCase();
    let subCmd = args[0];
    if (cmd == "key" && subCmd == "enchanted" && activeCommand == true) {
      e.cancel = true;
      world.getDimension("overworld").runCommandAsync(`clear @a[name="${e.sender.name}"] new:key2 0 1`);
      world.getDimension("overworld").runCommandAsync(`clear @a[name="${e.sender.name}"] minecraft:ender_pearl 0 1`);
      world.getDimension("overworld").runCommandAsync(`give @a[name="${e.sender.name}"] new:key 1 0 ${JSON.stringify(giveConfig)}`);
    }  
  }
});


//Functiones de deteccion de inventario
function getItems(inventory) {
  let items = [];
  if (inventory.size) {
    for (let i = 0; i < inventory.size; i++) {
      items.push(inventory.getItem(i));
    }
  } 
  else if (!inventory.size && inventory.container) {
    for (let i = 0; i < inventory.container.size; i++) {
      items.push(inventory.container.getItem(i));
    }
  }
  return items;
}
function findItem(items, item) {
  try {
    let res;
    if (item.amount == '*') {
      res = items.filter(it => it && item.typeId == it.typeId);
    } 
    else {
      res = items.filter(it => it && item.typeId == it.typeId && item.amount == it.amount);
    }
    return res.length > 0 ? items.indexOf(res[0]) : -1;
  } 
  catch (e) {}
}